package myfirst.test;

import org.seasar.extension.dataset.DataSet;
import org.seasar.extension.dataset.impl.SqlReader;
import org.seasar.extension.dataset.impl.XlsWriter;

import org.seasar.framework.container.S2Container;
import org.seasar.framework.container.factory.S2ContainerFactory;

public class Db2xls  {

  private void writeXlsFile1( S2Container container ) throws Exception  {

    SqlReader reader1 = (SqlReader)container.getComponent( "reader1" );
    XlsWriter writer1 = (XlsWriter)container.getComponent( "writer1" );
    writer1.write( reader1.read() );

  }

  private void writeXlsFile2( S2Container container ) throws Exception  {

    SqlReader reader2 = (SqlReader)container.getComponent( "reader2" );
    XlsWriter writer2 = (XlsWriter)container.getComponent( "writer2" );
    writer2.write( reader2.read() );

  }

  private void start( String diconFile ) throws Exception  {

    S2Container container = S2ContainerFactory.create( diconFile );
    container.init();

    writeXlsFile1( container );
    writeXlsFile2( container );

  }

  public static void main( String[] args ) throws Exception  {
    if ( args.length < 1 )  {
      System.out.println( "java [-cp %CLASSPATH%] Db2xls dicont@C" );
      System.exit( 1 );
    }
    Db2xls d2x = new Db2xls();
    d2x.start( args[ 0 ] );
  }

}