package myfirst.test;

import java.util.List;
import java.util.Map;

import org.seasar.extension.dataset.DataRow;
import org.seasar.extension.dataset.DataSet;
import org.seasar.extension.dataset.DataTable;
import org.seasar.extension.dataset.impl.DataSetImpl;
import org.seasar.extension.jdbc.SelectHandler;
import org.seasar.extension.unit.S2TestCase;

import junit.textui.TestRunner;

import myfirst.jdbc.*;

public class HandlerTest extends S2TestCase  {

  private static String DICON_FILE = "s2test.dicon";

  DataSet s2Test;

  public void initDataSet() throws Exception  {
    s2Test = new DataSetImpl();
    DataTable category = s2Test.addTable( "category" ); // e[u̐ݒ
    category.addColumn( "id" );                         // 񖼂̐ݒ(id)
    category.addColumn( "name" );                       // 񖼂̐ݒ(name)
    DataRow row1 = category.addRow();                   // 1sڂ̐
    row1.setValue( "id", 1 );                           // 1sڂ̃f[^̐ݒ
    row1.setValue( "name", "H" );                    // 1sڂ̃f[^̐ݒ
    DataRow row2 = category.addRow();                   // 2sڂ̐
    row2.setValue( "id", 2 );
    row2.setValue( "name", "ʔ" );
    DataRow row3 = category.addRow();                   // 3sڂ̐
    row3.setValue( "id", 3 );
    row3.setValue( "name", "Б" );
    DataRow row4 = category.addRow();                   // 4sڂ̐
    row4.setValue( "id", 4 );
    row4.setValue( "name", "M" );
    DataRow row5 = category.addRow();                   // 5sڂ̐
    row5.setValue( "id", 5 );
    row5.setValue( "name", "ƒ" );
    DataRow row6 = category.addRow();                   // 6sڂ̐
    row6.setValue( "id", 6 );
    row6.setValue( "name", "" );
  }

  public void testWithXlsFile() throws Exception  {
    DataSet fromXls = readXls( "account.xls" );
    assertNotNull( s2Test );
    // assertEquals( fromXls.getTable( "category" ), s2Test.getTable( "category" ) );
    assertEquals( fromXls, s2Test );
  }

  public void testWithMapList() throws Exception  {
    SelectHandler handler =
                (SelectHandler)getContainer().getComponent( "selectCategoryMapList" );
    // f[^擾(-Xlint:uncheckedIvVŁuLXgv̌x)
    List<Map> catList = (List<Map>)handler.execute( null );
    assertNotNull( s2Test );
    assertMapListEquals( "MapListŔr", s2Test, catList );
  }

  public void testWithDataSource() throws Exception  {
    DataTable category =
            readDbBySql( "SELECT id, name FROM category ORDER BY id", "category" );
    assertNotNull( s2Test );
    assertEquals( category, s2Test.getTable( "category" ) );
  }

  protected void setUp() throws Exception  {
    include( DICON_FILE );
    initDataSet();
  }

  public HandlerTest( String name ) {  super( name );  }

  public static void main( String[] args )  {
    TestRunner.run( HandlerTest.class );
  }

}